DSSP_path="../software/dssp"
x3dna_path="../software/x3dna-dssr"
import os
import sys
import numpy as np
options=sys.argv[1:]
def usage():
 print("Available command-line options:\n  -i Protein-DNA structure\n  -c Forward chain\n  -p Forward resid of the mutation\n  -w One letter of wild complementary nucleic acid base pair\n  -m One letter of mutant complementary nucleic acid base pair\n  -f List file\n  -o Output file(Optional)\n  -h Display this command-line summary")
def ss_snap(pdbid):
 os.system(DSSP_path+" -i "+pdbid+" -o pdb_dssp")
 os.system(x3dna_path+" --more -i="+pdbid+" -o=dna_detail >/dev/null 2>&1")
 os.system(x3dna_path+" snap -i="+pdbid+" -o=interaction_detail > num_inter 2>&1")
def remove_file():
 remove_list=["dssr-2ndstrs.bpseq","dssr-2ndstrs.ct","dssr-2ndstrs.dbn","dssr-helices.pdb","dssr-pairs.pdb","dssr-stems.pdb","dssr-torsions.txt"]
 for name in remove_list:
  os.remove(name)
def mutation_type(wild,mutation):
 lists = ['AA','AT','AG','AC','TA','TT','TG','TC','GA','GT','GG','GC','CA','CT','CG','CC']
 label_1=0
 label_2=0
 for i in lists:
  for j in lists:
   if i != j:
    label_1 += 1
    if wild == i:
     if mutation == j and i != j:
      label_2 = label_1
      break
 return label_2
def mismatch(wild,mutation):
 lists = ['AT','TA','GC','CG']
 if wild not in lists or mutation not in lists:
  return 1
 else:
  return 0
def pair_type(wild):
 if wild=="AT" or wild=="TA":
  return 1
 if wild=="GC" or wild=="CG":
  return 0
 return 2
def mutation_ss_label(SS_LABEL):
 label = {'H':'1','B':'2','E':'3','G':'4','I':'5','T':'6','S':'7'}
 return (label.get(SS_LABEL,0))
def mutation_ss():
 ss_index=['0','1','2','3','4','5','6','7']
 index=0
 ss_ratio=[]
 ss_ratio_list=[]
 for line in open("pdb_dssp"):
  info=line
  if index==1:
   ss_ratio.append(mutation_ss_label(info[16:17]))
  if info[2:10]=="#  RESID":
   index=1
 for i in ss_index:
  ss_ratio_list.append('%.2f'%(ss_ratio.count(i)/float(len(ss_ratio))))
 del(ss_ratio_list[0])
 del(ss_ratio_list[4]) #delete 0,5 columns ,all of them are 0.
 return(ss_ratio_list)
def dna_par(chain,resid,for_w,rev_w):
 index=0
 index_1=0
 index_2=0
 bp_par=[]
 bp_step=[]
 bp_heli=[]
 features=[]
 f=open("dna_detail")
 lines = f.readlines()
 i=0
 while i < len(lines):
  if " "+chain+".D"+for_w+resid+" " in lines[i] and ".D"+rev_w in lines[i]:
   if "bp-pars: [" in lines[i+5]:
    for num in lines[i+5].strip()[10:-1].split():
     try:
      float(num)
      bp_par.append(num)
     except ValueError:
      bp_par.append(0)
   elif "step-pars:  [" in lines[i+2]:
    for num in lines[i+2].strip()[13:-1].split():
     try:
      float(num)
      bp_step.append(num)
     except ValueError:
      bp_step.append(0)
    for num in lines[i+3].strip()[13:-1].split():
     try:
      float(num)
      bp_heli.append(num)
     except ValueError:
      bp_heli.append(0)
    break
  i=i+1
 while len(bp_par) < 6:
  bp_par.append(0)
 while len(bp_step) < 6:
  bp_step.append(0)
 while len(bp_heli) < 6:
  bp_heli.append(0)
 features=bp_par+bp_step+bp_heli
 return (features)
def snap():
 pro=0
 nuc=0
 h_bonds=0
 stack=0
 for line in open("num_inter"):
  info=line.strip()
  if "total number of nucleotide/amino-acid contacts:" in info:
   if len(info.split()) >2:
    nuc=info.split()[-1]
  elif "total number of phosphate/amino-acid H-bonds:" in info:
   if len(info.split()) >2:
    pro=info.split()[-1]
  elif "total number of base/amino-acid H-bonds:" in info:
   if len(info.split()) >2:
    h_bonds=info.split()[-1]
  elif "total number of base/amino-acid stacks:" in info:
   if len(info.split()) >2:
    stack=info.split()[-1]
 return(nuc,pro,h_bonds,stack)
def file_loop(pdbid,chain,wild_aa,position,mutation_aa,mutation_list):
 if wild_aa == mutation_aa:
  print("Wild type is same as Mutant, please check.")
  sys.exit()
 mutation_aa_list = ['AA','AT','AG','AC','TA','TT','TG','TC','GA','GT','GG','GC','CA','CT','CG','CC']
 if wild_aa not in mutation_aa_list or mutation_aa not in mutation_aa_list:
  print("Wild type or Mutant is not DNA.")
  sys.exit()
 if mutation_list==0:
  ss_snap(pdbid)
  remove_file()
 label = []
 label.append(mutation_type(wild_aa,mutation_aa))
 label.append(mismatch(wild_aa,mutation_aa))
 label.append(pair_type(wild_aa))
 label=label+mutation_ss()
 (a,b,c,d)=snap()
 label.append(a)
 label.append(b)
 label.append(c)
 label.append(d)
 label=label+dna_par(chain,position,wild_aa[0],wild_aa[1])
 #for i in label:
  #print i,
 return(pred_feature(label))
def pred_feature(label):
 model=xgb.Booster(model_file='regression_nuc.model')
 x=np.array(label)
 #x=pd.DataFrame(x)
 #x=x.iloc[:,[-1]].values
 x=x.reshape((1,len(label)))
 x=xgb.DMatrix(x)
 y_pred = model.predict(x)
 if y_pred[0]>0:
  output="%.2f"%y_pred[0]+" Destabilizing"
 else:
  output="%.2f"%y_pred[0]+" Stabilizing"
 return (output)
import getopt
import xgboost as xgb
opts, args = getopt.getopt(sys.argv[1:], "hi:c:p:w:m:f:o:", ["help", "input=","chain=","position=","wild=","mutation","file", "output="])
for op, value in opts:
 if op == "-i":
  pdbid = value
 elif op == "-c":
  chain = value
 elif op == "-p":
  position = value
 elif op == "-w":
  wild_aa= value
 elif op == "-m":
  mutation_aa = value
 elif op == "-o":
  output_name = value
 elif op == "-f":
  file_name = value
 elif op == "-h":
  usage()
  sys.exit()
try:
 file_name
except NameError:
 try:
  output_name
 except NameError:
  pred=file_loop(pdbid,chain,wild_aa,position,mutation_aa,0)
  print(pred)
 else:
  f = open(output_name, 'w')
  print("Forward_chain wild_basepair Forward_position Mutant_basepair ddG Type", file=f)
  pred=file_loop(pdbid,chain,wild_aa,position,mutation_aa,0)
  print(chain,wild_aa,position,mutation_aa,pred, file=f)
  f.close()
else:
 try:
  output_name
 except NameError:
  list_index=0
  for line in open(file_name):
   info=line.strip().split()
   if list_index==0:
    pred=file_loop(pdbid,info[0],info[1],info[2],info[3],0)
    print(pred)
    list_index=1
   else:
    pred=file_loop(pdbid,info[0],info[1],info[2],info[3],1)
    print(pred)
  sys.exit()
 else:
  list_index=0
  f = open(output_name, 'w')
  print("Forward_chain wild_basepair Forward_position Mutant_basepair ddG Type", file=f)
  for line in open(file_name):
   info=line.strip().split(' ')
   if list_index==0:
    pred=file_loop(pdbid,info[0],info[1],info[2],info[3],0)
    print(info[0],info[1],info[2],info[3],pred, file=f)
    list_index=1
   else:
    pred=file_loop(pdbid,info[0],info[1],info[2],info[3],1)
    print(info[0],info[1],info[2],info[3],pred, file=f)
  f.close()
